#include <iostream>
#include <string>
#include <map>
#include <cstdlib>
#include <time.h>
using namespace std;




     multimap< long, long >   weight_id_map;
     long mycounter; // a simple counter; nothing to do with weight_id_map

extern "C" {

// two routines to manipulate mycounter
void mycounter_set(long counterval) {
  mycounter = counterval;
}

long mycounter_dec () {
  return --mycounter;
}




void myheap_reset() {
 cout << "mymultimap_reset(); \n";
 weight_id_map.erase(weight_id_map.begin(),weight_id_map.end());
 // can probably be done faster
}

void myheap_initialize() {
 srand ( time(NULL) );
 myheap_reset();
}

void myheap_add_node_at_front(long nodeid){
   //cout << "mymultimap_add_node_at_front: " << nodeid  << endl;
    if(weight_id_map.empty()) {
		weight_id_map.insert( pair<long, long>( 1, nodeid) );
	 } else {
	    weight_id_map.insert( pair<long, long>( weight_id_map.begin()->first - 1, nodeid) );
	 }
}
void myheap_add_node_at_end(long nodeid){
   //cout << "mymultimap_add_node_at_end: " << nodeid  << endl;
 	if(weight_id_map.empty()) {
		weight_id_map.insert( pair<long, long>( 1, nodeid) );
	 } else {
		weight_id_map.insert( pair<long, long>( (--weight_id_map.end())->first + 1, nodeid) );
     }
}

void myheap_add_node_random(long nodeid){
 // cout << "mymultimap_add_node: " << nodeid << "," << nodeweight << endl;
 weight_id_map.insert( pair<long, long>( rand(), nodeid) );
}

void myheap_add_node(long nodeid, long nodeweight){
 // cout << "mymultimap_add_node: " << nodeid << "," << nodeweight << endl;
 weight_id_map.insert( pair<long, long>( nodeweight, nodeid) );
}

long myheap_size(){
  return weight_id_map.size();
}

long myheap_empty(){
  if(weight_id_map.empty())
     return 1;
  else
     return 0;
}

long myheap_top_weight(){
  return weight_id_map.begin()->first;
}
long myheap_top_id(){
  return weight_id_map.begin()->second;
}

long myheap_max_weight(){
  return (--weight_id_map.end())->first;
}

long myheap_pop(){
 if(weight_id_map.empty()) {
   cout << "empty multimap in pop" << endl;
   return -1;
 } else {
	multimap< long, long >::iterator iter = weight_id_map.begin();
    long resid = iter->second;
    long resweight = iter->first;
   // cout << "mymultimap_pop: " << resid << ":" << resweight << endl;
    //weight_id_map.erase(resid);
    weight_id_map.erase(iter++,iter);
 	return resid;
 }
}


long myheap_pop_max(){
 if(weight_id_map.empty()) {
   cout << "empty multimap in pop_max" << endl;
   return -1;
 } else {
	multimap< long, long >::iterator iter = weight_id_map.end();
    long resid = (--iter)->second;
    long resweight = iter->first;
   // cout << "mymultimap_pop_max: " << resid << ":" << resweight << endl;
    //weight_id_map.erase(resid);
    weight_id_map.erase(iter++,iter);
 	return resid;
 }
}

void myheap_portray(){
if(weight_id_map.empty()) {
  cout << "empty multimap" << endl;
} else {
	cout << "< ";
	multimap< long, long >::iterator iter = weight_id_map.begin();
	while (iter != weight_id_map.end()) {
		cout << "(" << iter->first << "," << iter->second << ") "	;
		iter++;
	}
	cout << " >" << endl;
}
}
}