#ifndef WTOK_INCLUDED
#define WTOK_INCLUDED
#include <sicstus/sicstus.h>
#include "../../../common/queue.h"

extern wQueue *local_queue;
extern int assertion_mode;

void tick(void);
void init_tok(zctx_t *ctx, zmq_pollitem_t *poller, SP_pred_ref check_pred_ref);
void teardown_tok(zctx_t *ctx);
int h_tick (zloop_t *loop, zmq_pollitem_t *poller, void *arg);
void put_successor(char *term, int len,
                   char *digest, SP_term_ref ignored);
char *shachar(char *term, int len);

#endif
