:- module(tools_io,[safe_open_file/4]).

:- use_module(module_information).
:- module_info(group,infrastructure).
:- module_info(description,'This module contains file io helper predicates.').

:- use_module(error_manager).

safe_open_file(Filename,Mode,Stream,Options) :- print(opening(Filename)),nl,
    on_exception(error(A,B),open(Filename,Mode,Stream,Options),
       (add_error(open_file,'Exception occurred opening file: ',error(A,B)),fail)).
