@echo off
echo "*------------------------*"
echo "Compiling latest ProB.sav"
echo "*------------------------*"
echo "*------------------------*"
echo "*------------------------*"
echo "*------------------------*"
chdir \cygwin\home\leuschel\svn_root\NewProB\
sicstus -l src\prob_tcltk.pl --goal "save,gen,halt."

mkdir ProB_Win\

echo "copying ProBLicence.txt,ProBSummary.txt into ProB/"
move tcl\ProBLicence.txt ProB\
move tcl\ProBSummary.txt ProB\

echo "Running vsvars32"
echo C:\Programme\Microsoft Visual Studio 8\Common7\Tools\vsvars32

echo "------------------------"
echo "Generating Windows Binary"
echo "------------------------"
move ProB.sav ProB_Win\
chdir ProB_Win\
echo "Generating Windows Binary (you may have to create a directory and tcl84.lib and tk84.lib)"
spld --static  --with-tcltk=C:\Tcl --output .\ProBWin.exe --resources=.\ProB.sav=/ProB.sav --userhook ..\extensions\initialisation\SU_initialize.c --verbose
echo "Finished Windows Binary"
chdir ..
move ProB_Win\ProB.sav .

echo "Copying VC8 Redistribution DLLs"
copy VC8_redist_x86\Microsoft.VC80.CRT\Microsoft.VC80.CRT.manifest ProB_Win\Microsoft.VC80.CRT\
copy VC8_redist_x86\Microsoft.VC80.CRT\msvcm80.dll ProB_Win\Microsoft.VC80.CRT\
copy VC8_redist_x86\Microsoft.VC80.CRT\msvcp80.dll ProB_Win\Microsoft.VC80.CRT\
copy VC8_redist_x86\Microsoft.VC80.CRT\msvcr80.dll ProB_Win\Microsoft.VC80.CRT\


echo "Copying Icons"
mkdir ProB_Win\tcl
mkdir ProB_Win\tcl\icons
copy tcl\icons\prob_icon-win32.ico ProB_Win\tcl\icons\
copy tcl\icons\prob_logo.gif ProB_Win\tcl\icons\
copy tcl\icons\invKO.gif ProB_Win\tcl\icons\
copy tcl\icons\invKO.gif ProB_Win\tcl\icons\
copy tcl\icons\Maxreach.gif ProB_Win\tcl\icons\
copy tcl\icons\invUnknown.gif ProB_Win\tcl\icons\
copy tcl\icons\invTimeout.gif ProB_Win\tcl\icons\
copy tcl\icons\Timeout.gif ProB_Win\tcl\icons\
copy tcl\icons\MaxreachEmpty.gif ProB_Win\tcl\icons\
copy tcl\icons\MaxreachSym.gif ProB_Win\tcl\icons\
copy tcl\icons\TimeoutEmpty.gif ProB_Win\tcl\icons\
copy tcl\icons\TimeoutEmpty.gif ProB_Win\tcl\icons\
copy tcl\icons\BackEnabled.gif ProB_Win\tcl\icons\
copy tcl\icons\ForwardEnabled.gif ProB_Win\tcl\icons\
copy tcl\icons\InvRef.gif ProB_Win\tcl\icons\
copy tcl\icons\Change.gif ProB_Win\tcl\icons\

echo "Generating lib"
mkdir ProB_Win\lib\


echo "Copy remaining DLLs and jars into ProB_Win\lib"
echo "Copying probcliparser.jar"
copy lib\probcliparser.jar ProB_Win\lib\
echo "Copying graphiso.dll"
copy lib\graphiso.dll ProB_Win\lib\
echo "Copying cspm.exe"
copy lib_platform_specific\windows\cspm.exe ProB_Win\lib
echo "Copying ltlc.dll"
copy lib\ltlc.dll ProB_Win\lib\
echo "Copying probhash.dll"
copy lib\probhash.dll ProB_Win\lib\
echo "Copying Promela.jar"
copy lib\Promela.jar ProB_Win\lib\
# echo "Copying aspectjrt.jar"
# copy lib\aspectjrt.jar ProB_Win\lib\
echo "Copying send_user_interrupt.exe"
copy lib_platform_specific\windows\send_user_interrupt.exe ProB_Win\lib\
echo "Copying user_signal.dll"
copy lib_platform_specific\windows\user_signal.dll ProB_Win\lib\
echo "Finished"
echo %INCLUDE%
pause
