#include <iostream>
#include <string>
#include <map>
using namespace std;




     map< long, long >   pq;

extern "C" {

void myheap_reset() {
 cout << "mymap_reset(); \n";
 pq.erase(pq.begin(),pq.end());
 // can probably be done faster
}

void myheap_add_node(long nodeid, long nodeweight){
 cout << "myheap_add_node: " << nodeid << "," << nodeweight << endl;
 pq.insert( pair<long, long>( nodeid, nodeweight) );
}

long myheap_size(){
  return pq.size();
}

long myheap_empty(){
  if(pq.empty())
     return 1;
  else
     return 0;
}

long myheap_top_id(){
  return pq.begin()->first;
}
long myheap_top_weight(){
  return pq.begin()->second;
}

long myheap_pop(){
 if(pq.empty()) {
   cout << "empty map" << endl;
   return -1;
 } else {
	map< long, long >::const_iterator iter = pq.begin();
    long resid = iter->first;
    long resweight = iter->second;
    cout << "myheap_pop: " << resid << ":" << resweight << endl;
    pq.erase(resid);
 	return resid;
 }
}
}