#ifndef MBALANCER_INCLUDED
#define MBALANCER_INCLUDED

#include "../../../common/queue.h"

extern int checked_states;
extern wQueue *assertions;

void init_work_balancer(zctx_t *ctx, zmq_pollitem_t *poller, int qsize, int port_start);
void start_work_balancer(pthread_t *thread);
void teardown_work_balancer(zctx_t *ctx);

void start_work(char *fwp, int fwp_len);
void start_work_assertion(int number_of_assertions);
void set_empty_workers(int empty);

int get_q_size(int worker);
#endif
