#include "../../../include/zmq.h"
#include "../../../include/czmq.h"

#include "wdebug.h"

void *debug_printer = NULL;
int debug_level;

void init_worker_printer(zctx_t *ctx, int lvl, char *masteraddr, int port, char *wid) {
    debug_level = lvl;
    debug_printer = zsocket_new(ctx, ZMQ_PUSH);
    zsocket_connect(debug_printer,"tcp://%s:%i", masteraddr, port+6);
}

void stop_worker_printer(zctx_t *ctx) {
    zsocket_destroy(ctx, debug_printer);
    debug_printer = NULL;
}

//void send_debug_text(char *txt, int level) {
//    if (level >= debug_level) {
//        struct timeval tmpgt;
//        gettimeofday(&tmpgt, NULL);
//        int timestamp = ((int)tmpgt.tv_sec * 1000) + (int)(tmpgt.tv_usec/1000);
//        zstr_sendf(debug_printer, "{:type :debug :source :worker :id %s :level %d :timestamp %d %s}\n", id, level, timestamp, txt);
//    }
//}
