#!/bin/bash
PROBCOMMAND=probcli


if [ $# -lt 3 ] 
then
	echo "Too few parameters ($#) for parB"
	echo "Usage ./parB <Nr. of workers> <logfile> <file>"
	exit -1
else 
	echo "Running ProB in Parallel (on .prob files)"	
	# dirname
	if [ -h "$0" ]
	then
	    realname=`readlink "$0"`
	    dirname=`dirname "$realname"`
	else
	    dirname=`dirname "$0"`
	fi
	
	#ulimit -d unlimited
	
	echo "Directory: $dirname"

# dirname
if [ -h "$0" ]
then
    realname=`readlink "$0"`
    dirname=`dirname "$realname"`
else
    dirname=`dirname "$0"`
fi

#ulimit -d unlimited

# setting the library path to find the zmq shared libraries
system=`uname`
if [ $system = "Linux" ]; then
  export LD_LIBRARY_PATH="$dirname/lib"
fi

echo "Directory: $dirname"
#cd $dirname
#ls
nmbr_wrkrs=$1
echo "Starting workers in parallel"
for ((  i = 0 ;  i < $1;  i++  ))
do
  "$dirname/$PROBCOMMAND" -zmq_worker -bf &
done
echo "Starting hash server: $dirname/extensions/zmq/shm-srv/hasher localhost 5000 1 "
"$dirname/extensions/zmq/shm-srv/hasher" localhost 5000 1 &
shift
echo "Starting master: $dirname/$PROBCOMMAND -bf -zmq_master " $*
time "$dirname/$PROBCOMMAND" -bf -zmq_master $*
fi
